.Dd 2017-05-23
.Dt RB79 1
.Os
.Sh NAME
.Nm RB-79
.Nd A feature-light imageboard.
.Sh DESCRIPTION
The
.Nm
suite contains an imageboard server and programs to moderate it.
.Sh FILES
All of
.Nm
is governed by the configuration file
.Pa config.h
at compilation time. Any variables referred to are defined in this
file.
.Pp
While running,
.Nm
uses file paths defined by the variables
.Va static_www_folder
and
.Va work_path .
These folders should be readable by the web-server and writable by
the user running
.Nm  rb79-server .
.Pp
.Bl -tag -width Ds
.It Va static_www_folder
is the folder which
.Nm
expects will be the root folder of the web server.
.It Va work_path
is the folder where
.Nm
will store the post databases and lock files.
.El
.Sh LOCKING AND PARALLELISM
.Nm
relies on the underlying database to provide locking. The server
is single-threaded. To provide scalability and coordination with
utility programs, the
.Xr lockf 3
mechanism is used.
.Sh API
Assuming the site is at
.Va URL
.Bl -bullet -compact
.It
Boards are at
.Va URL Ns / Ns Va board_name
.It
Threads are at
.Va URL Ns / Ns Va board_name Ns /res/ Ns Va thread_number
.It
Media files are at
.Va URL Ns / Ns Va board_name Ns /src/ Ns Va timestamp Ns . Ns Va extension
.El
.Pp
Posting can be accessed by POSTing multipart/form-data to the
.Va URL Ns /action
endpoint.
.Pp
.Dl % curl -X POST Va URL Ns /action \e\ 
.Dl \& \& \& \& \& \& \& -F action=reply \e\ 
.Dl \& \& \& \& \& \& \& -F board=m \e\ 
.Dl \& \& \& \& \& \& \& -F thread=123 \e\ 
.Dl \& \& \& \& \& \& \& -F 'name=John#trip' \e\ 
.Dl \& \& \& \& \& \& \& -F email=sage \e\ 
.Dl \& \& \& \& \& \& \& -F subject=Hello \e\ 
.Dl \& \& \& \& \& \& \& -F file=@/tmp/picture.jpg \e\ 
.Dl \& \& \& \& \& \& \& -F 'comment=I like this picture.' \e\ 
.Dl \& \& \& \& \& \& \& -F challengeid=1 \e\ 
.Dl \& \& \& \& \& \& \& -F challengeresponse=ball
.Pp
Most parameters are straightforward.
.Pp
.Bl -bullet -compact
.It
.Va action
is one of
.Dq reply
.Po this necessitates a
.Va thread
parameter
.Pc
.Dq newthread ,
or
.Dq rebuild 
.Po
this is only accepted from the local machine, and rebuilds all
static files
.Pc .
.It
.Va challengeid
and
.Va challengeresponse
must be a matching pair from the
.Va challenges
array of
.Pa config.h .
.El
.Sh MODERATION
Moderation is typically performed by editing the relevant databases,
then forcing a rebuild via
.Pp
.Dl % curl -X POST Va URL Ns /action -F action=rebuild
.Pp
from the server
.Po
.Dq rebuild
is only accepted from a local IP address
.Pc ,
or the associated convenience programs may be used:
.Pp
.Bl -bullet -compact
.It
.Xr rb79-view-thread 1
.El
.Sh AUTHORS
.An De Rais Aq Mt derais@cock.li
